# -*- coding: utf-8 -*-
"""
Created on Sun Jun  4 16:12:39 2023

@author: Ysc
"""

import os
import tensorflow as tf
from tensorflow import keras
import matplotlib.pyplot as plt

(train_images, train_labels), (test_images, test_labels) = tf.keras.datasets.mnist.load_data()

# 샘플 이미지 하나 출력
index = 3
plt.imshow(test_images[index], cmap='gray')
plt.title(f"Label: {test_labels[index]}")
plt.show()

train_labels = train_labels[:60000]
test_labels = test_labels[:10000]

train_images = train_images[:60000].reshape(-1, 28 * 28) / 255.0
test_images = test_images[:10000].reshape(-1, 28 * 28) / 255.0



# Define a simple sequential model
def create_model():
  model = tf.keras.Sequential([
    keras.layers.Dense(512, activation='relu', input_shape=(784,)),
    keras.layers.Dense(128, activation='relu'),
    keras.layers.Dropout(0.2),
    keras.layers.Dense(10)
  ])

  model.compile(optimizer='adam',
                loss=tf.keras.losses.SparseCategoricalCrossentropy(from_logits=True),
                metrics=[tf.keras.metrics.SparseCategoricalAccuracy()])

  return model

# Create a basic model instance
model = create_model()

# Display the model's architecture
model.summary()

checkpoint_path = "training_1/cp.ckpt"
checkpoint_dir = os.path.dirname(checkpoint_path)
print('dir name : ', os.listdir(checkpoint_dir))


# Create a basic model instance
model = create_model()


# Loads the weights
model.load_weights(checkpoint_path)

# Re-evaluate the model itself
loss, acc = model.evaluate(train_images, train_labels, verbose=2)
print("Already trained model, accuracy: {:5.2f}%".format(100 * acc))

# Re-evaluate the model
loss, acc = model.evaluate(test_images, test_labels, verbose=2)
print("Restored model, accuracy: {:5.2f}%".format(100 * acc))

"""
샘플 계산 사례
dir name :  ['checkpoint', 'cp.ckpt.data-00000-of-00001', 'cp.ckpt.index']
1875/1875 - 4s - loss: 0.0106 - sparse_categorical_accuracy: 0.9966 - 4s/epoch - 2ms/step
Already trained model, accuracy: 99.66%
313/313 - 1s - loss: 0.0850 - sparse_categorical_accuracy: 0.9811 - 905ms/epoch - 3ms/step
Restored model, accuracy: 98.11%
"""
